<?php

namespace Teknisa\FIS\Modules\Relatorios\Controllers;

use Teknisa\FIS\Controllers\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\Masks\Masks;
use Zeedhi\Framework\DTO;

class Fis00098RelatorioCustomizavel extends TeknisaCrud {
	protected $masks;

	public function __construct($crudService, $parameterBag, Masks $masks) {
    	parent::__construct($crudService, $parameterBag);
    	$this->masks = $masks;
  	}

	public function find(DTO\Request\Filter $request, DTO\Response $response) {
		$dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()));
        $this->dataSourceName = $dataSource;
		parent::find($request, $response);
		$dataSets = $response->getDataSets();

		if (!empty($dataSets)) {
			$dataSet = $dataSets[0]->getRows();

			foreach ($dataSet as $key => $value) {
				if (isset($value['NRINSJUREMPR']) && $value['IDTPIJUREMPR'] === 'J') {
					$dataSet[$key]['NRINSJUREMPR'] = $this->masks->mask($value['NRINSJUREMPR'], '##.###.###/####-##');
				}
			}
			$newDataSet = new DataSet($this->dataSourceName, $dataSet);
            $response->setDataSets(array($newDataSet));
		}


	}

}