<?php
namespace Teknisa\FIS\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Fis00700DocumentosFiscais extends \Zeedhi\Framework\Controller\Report {

    protected $novoCodigo;
    protected $procedureNutriente;
    protected $parameterBagColumns;
    protected $entityManager;
    protected $qr2Strategy;
    protected $nrsequnutr;
    protected $cdfilial;
    protected $nrorg;
    protected $connection;

    public function __construct($reportService, $novoCodigo, $entityManager, $qr2Strategy, $connection) {
        
        $this->reportService      = $reportService;
        $this->novoCodigo         = $novoCodigo;
        $this->entityManager      = $entityManager;
        $this->qr2Strategy        = $qr2Strategy;
        $this->connection         = $connection;
  
    }

    protected $reportMapping = array (
        //Realtórios Federeais
        'FIS98001' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'PRODUTOINI'      => 'P_PRODUTOINI',
                'PRODUTOFIN'      => 'P_PRODUTOFIN',
                'REGIME'          => 'P_REGIME',
            ),
        ),
        'FIS98002' =>   
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'PRODUTOINI'      => 'P_PRODUTOINI',
                'PRODUTOFIN'      => 'P_PRODUTOFIN',
                'REGIME'          => 'P_REGIME',
            ),
        ),
        'FIS98003' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'PRODUTOINI'      => 'P_PRODUTOINI',
                'PRODUTOFIN'      => 'P_PRODUTOFIN',
                'NVTOT'           => 'P_NVTOT',
                'LISTARPROD'      => 'P_LISTAPROD',
                'REGIME'          => 'P_REGIME',
            ),
        ),
         'FIS98004' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'PRODUTOINI'      => 'P_PRODUTOINI',
                'PRODUTOFIN'      => 'P_PRODUTOFIN',
                'NVTOT'           => 'P_NVTOT',
                'LISTARPROD'      => 'P_LISTAPROD',
                'REGIME'          => 'P_REGIME',
            ),
        ),
        'FIS98005' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'REGIME'          => 'P_REGIME',
            ),
        ),
       'FIS98006' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'REGIME'          => 'P_REGIME',
            ),
        ),
        'FIS98007' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'REGIME'          => 'P_REGIME',
            ),
        ),
        'FIS98008' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
            ),
        ),
         'FIS98009' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
            ),
        ),
         'FIS98011' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'P_NRORG',
                'CDEMPRESA'       => 'P_CDEMPRESA',
                'CDLIVROMAG'      => 'P_CDLIVROMAG',
                'DTINICIO'        => 'P_DTINICIO',
                'DTFINAL'         => 'P_DTFINAL',
                'PRODUTOINI'      => 'P_PRODUTOINI',
                'PRODUTOFIN'      => 'P_PRODUTOFIN',
                'REGIME'          => 'P_REGIME',
            ),
        ),
        //Relatórios Estaduais
        'FII00100' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'             => 'NRORG',
                'CDEMPRESA'         => 'CDEMPRESA',
                'CDIMPOSTONFE'      => 'CDIMPOSTO',
                'CDINSCESTA'        => 'CDINSCESTA',
                'DTINICIO'          => 'DTINIPERIODO',
                'DTFINAL'           => 'DTFIMPERIODO',
                'NRPAGINA'          => 'NRPAGINA',
            ),
        ),
        'FII00300' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'                 => 'NRORG',
                'CDEMPRESA'             => 'CDEMPRESA',
                'CDINSCESTA'            => 'CDINSCESTA',
                'CDIMPOSTONFE'          => 'CDIMPOSTO',
                'DTINICIO'              => 'DTINIPERIODO',
                'DTFINAL'               => 'DTFIMPERIODO',
                'NRPAGINA'              => 'NRPAGINA',
            ),
        ),
         'FII00303' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'                 => 'NRORG',
                'CDEMPRESA'             => 'CDEMPRESA',
                'CDINSCESTA'            => 'CDINSCESTA',
                'CDIMPOSTONFE'          => 'CDIMPOSTO',
                'DTINICIO'              => 'DTINIPERIODO',
                'DTFINAL'               => 'DTFIMPERIODO',
            ),
        ),
        'FII00325' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'                 => 'NRORG',
                'CDEMPRESA'             => 'CDEMPRESA',
                'CDINSCESTA'            => 'CDINSCESTA',
                'CDIMPOSTONFE'          => 'CDIMPOSTO',
                'DTINICIO'              => 'DTINIPERIODO',
                'DTFINAL'               => 'DTFIMPERIODO',
                'NRPAGINA'              => 'NRPAGINA',
               
            ),
        ),
        'FII00500' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'CDIMPOSTONFE'    => 'CDIMPOSTO',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
                'NRLIVRO'         => 'NRLIVRO',
            ),
        ),
        'FII00600' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'CDIMPOSTONFE'    => 'CDIMPOSTO',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
                'NRLIVRO'         => 'NRLIVRO',
            ),
        ),
        'FII00800' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'CDIMPOSTONFE'    => 'CDIMPOSTO',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA'
            ),
        ),
        'FII00802' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'CDIMPOSTONFE'    => 'CDIMPOSTO',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
            ),
        ),
        'FII00890' => 
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'CDIMPOSTONFE'    => 'CDIMPOSTO',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
                'NRLIVRO'         => 'NRLIVRO',
            ),
        ),
        //Relatórios SimplesNacionais
        'FIS60000' =>  
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
                'NRLIVRO'         => 'NRLIVRO',
            ), 
        ), 
        'FIS60001' =>  
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
                'NRLIVRO'         => 'NRLIVRO',
            ), 
        ), 
        'FIS60002' =>  
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCMUNI'      => 'CDINSCESTA',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
            ), 
        ), 
         'FIS60003' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCMUNI'      => 'CDINSCESTA',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
            ), 
        ), 
        'FIS60004' =>  
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'CDINSCESTA'      => 'CDINSCESTA',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
            ), 
        ),
        'FIS60005' =>  
        array (
            'strategy' => 'QR2',
            'parameterMapping' => 
            array (
                'NRORG'           => 'NRORG',
                'CDEMPRESA'       => 'CDEMPRESA',
                'DTINICIO'        => 'DTINIPERIODO',
                'DTFINAL'         => 'DTFIMPERIODO',
                'NRPAGINA'        => 'NRPAGINA',
            ), 
        ),

    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }
}